module PublicTests where

import Poly
import HaskellUnit
import Data.Ratio

tests = [test1,test2,test3,test4,test5,test6,test7,test8,test9,test10,test11,test12,test13,test14,test15,test16,test17,test18,test19,test20]

test1 = testcase "x-Quadrat 1" "(1⁻^2)§5 falsch" 25 ((1#^2)§5)
test2 = testcase "x-Quadrat 2" "(1⁻^2)§0 falsch" 0 ((1#^2)§0)
test3 = testcase "x-Quadrat (5%3)" "(1⁻^2)§(5%3) falsch" (25%9) ((1#^2)§(5%3))
test4 = testcase "x-Quadrat -1" "(1⁻^2)§(-1) falsch" 1 ((1#^2)§(-1))
p5 = P[M 0 17,M 2 2,M 4 2,M (-3) 3]
test5 = testcase "normalize1" ("normalize "++show p5++" falsch") (P [M ((-3) % 1) 3,M (6 % 1) 2]) (normalize p5)
p6 = P[M 2 2,M (-1) 2,M (-1) 2]
test6 = testcase "normalize2" ("normalize "++show p6++" falsch") (P []) (normalize p6)
test7 = testcase "add1" ("add "++show p6++" "++show p6++") falsch") (P []) (p6 `add` p6)
test8 = testcase "mult1" ("mult "++show p6++" "++show p6++") falsch") (P []) (p6 `mult` p6)
test9 = testcase "add2" ("add "++show p5++" "++show p6++") falsch") (P [M ((-3) % 1) 3,M (6 % 1) 2]) (p5 `add` p6)
test10 = testcase "mult2" ("mult "++show p5++" "++show p6++") falsch") (P []) (p5 `mult` p6)

test11 = testcase "add3" ("add "++show p5++" "++show p5++") falsch") (P [M ((-6) % 1) 3,M (12 % 1) 2] ) (p5 `add` p5)
test12 = testcase "mult3" ("mult "++show p5++" "++show p5++") falsch") (P [M (9 % 1) 6,M ((-36) % 1) 5,M (36 % 1) 4]) (p5 `mult` p5)

p13 = P [M (6 % 1) 6,M ((-2) % 1) 5,M ((-4) % 1) 3,M (3 % 1) 1,M (3 % 1) 0]
p14 = P [M (2 % 1) 3,M (2 % 1) 1,M ((-3) % 1) 0]

test13 = testcase "/% 1" ((show p13)++"/%"++(show p14)  ++" falsch") (P [M (3 % 1) 3,M ((-1) % 1) 2,M ((-3) % 1) 1,M (7 % 2) 0],P [M (3 % 1) 2,M ((-13) % 1) 1,M (27 % 2) 0]) (p13/%p14)
test14 = testcase "/% 2" ((show p13)++"/%"++(show p13)  ++" falsch") (P [M (1 % 1) 0],P []) (p13/%p13)
test15 = testcase "/% 3" ((show p14)++"/%"++(show p14)  ++" falsch") (P [M (1 % 1) 0],P []) (p14/%p14)
test16 = testcase "/% 4" ((show p14)++"/%"++(show p13)  ++" falsch") (P [],P [M (2 % 1) 3,M (2 % 1) 1,M ((-3) % 1) 0]) (p14/%p13)

test17 = testcase "derivation 1" ("(derivation "++show p13++") falsch") (P [M (36 % 1) 5,M ((-10) % 1) 4,M ((-12) % 1) 2,M (3 % 1) 0]) (derivation p13)
test18 = testcase "derivation 2" ("(derivation "++show p14++") falsch") (P [M (6 % 1) 2,M (2 % 1) 0]) (derivation p14)
test19 = testcase "derivation 3" ("(derivation "++show p5 ++") falsch") (P [M ((-9) % 1) 2,M (12 % 1) 1]) (derivation p5)
test20 = testcase "derivation 4" ("(derivation "++show p6 ++") falsch") (P []) (derivation p6)
